/* the include file used by applications using the amphibian
   library, which provides access to a locally running
   fishnet node.  Do not link such apps with libfish!. */

#ifndef _AMPHIBIAN_APP_H
#define _AMPHIBIAN_APP_H
#include <sys/socket.h>

#ifndef FALSE
#define FALSE (0) 
#define TRUE (!FALSE)
typedef int boolean;
#endif

/* arbitrarily higher than AF_MAX == 32*/
#define AF_FISH 64
struct sockaddr_fish {
  sa_family_t sfish_family;
  int sfish_address;
  int sfish_port;
};

struct connection_request {
  int connect_not_bind;
  struct sockaddr_fish dst;
};

/* returns the new socket */
/* domain should be AF_FISH, type SOCK_STREAM, protocol is unused */
int fishsockets_socket(int domain, int type, int protocol); 
/* returns 0 on success, -1 on failure */
int fishsockets_connect(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen);
/* returns 0 on success, -1 on failure */
int fishsockets_bind(int sockfd, struct sockaddr *my_addr, socklen_t addrlen);
/* returns the accepted socket */
int fishsockets_accept(int sockfd, struct sockaddr *remote_addr, socklen_t *addrlen);
/* read, write, and close are essentially unchanged, but we define 
   fishsockets_ versions of them for consistency and in case we have
   to change our minds. */
#define fishsockets_read  read
#define fishsockets_write write
#define fishsockets_close close

#define CONNECT_FAILED "failed"
#define CONNECT_SUCCESS "connected"

#define FISH_SERVICE_ECHO 7    /* client sends data, server sends it back */
#define FISH_SERVICE_DISCARD 9 /* client sends data, server dumps it */
#define FISH_SERVICE_FONE 411  /* client sends 16 kHz, 2 channel, 16 bit sound */
#endif

